<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;

class ProcesarComent extends Controller
{
    public function procesar(Request $request)
    {
           // Obtener el cuerpo de la solicitud como texto
      $rawData = $request->getContent();

      // Dividir el texto en líneas y limpiar las líneas vacías y espacios adicionales
      $jsonLines = array_filter(array_map('trim', explode("\n", $rawData)));

      // Array para almacenar los objetos individuales
      $cleanedData = [];

      // Iterar sobre cada línea que contiene un objeto JSON
      foreach ($jsonLines as $jsonLine) {
          try {
              $decodedLine = json_decode($jsonLine, true);
              if ($decodedLine !== null) {
                  $cleanedData[] = $decodedLine;
              }
          } catch (\Exception $e) {
              // Manejar el error si la decodificación falla
              // Omitir este objeto y continuar con la siguiente línea
          }
      }

      // Devolver el arreglo limpio como JSON correctamente formateado
      return response()->json($cleanedData);
    }
}
